;
;                   Digital Alarm Clock from the MK14 Manual
;
;       A slightly strange use of an emulator , this one, but quite
;       useful for speed checking an emulator
;

CRom    =       010Bh                   ; Hex -> 7 Segment Convert
Disp    =       0D00h                   ; Display address

Row     =       0F10h+1                 ; Variable. As its referred to
                                        ; relatively, we have to add 1 Grrr

        .org    0F16h

Time:   .db     12h                     ; Hours
        .db     0                       ; mins
        .db     0                       ; seconds
        .db     0

        .db     76h                     ; 24 hours
        .db     40h                     ; 60 mins
        .db     40h                     ; 60 seconds
Speed:  .db     02h                     ; speed adjust

        .org    0F20h

Clock:  ldi     CRom / 256              ; P3 = CROM
        xpah    3
        ldi     CRom & 255
        xpal    3
New:    ldi     Disp / 256              ; P2 = Disp + 0dH
        xpah    2                       ; an imaginary digit (the last two)
        ldi     (Disp & 255) + 0Dh      ; written to unmapped display
        xpal    2

        ldi     Time / 256              ; P1 = Time+4
        xpah    1
        ldi     (Time & 255) + 4
        xpal    1

        scl                             ; start by adding 1 !
        ldi     5                       ; Loop count
        st      Row
Again:  ld      @-1(1)                  ; increment it
        dai     0
        st      0(1)
        dad     4(1)                    ; adjust & check overflow
        jz      Cs                      ; zero here forces overflow
        jz      Cs                      ; balances the clock
        jmp     Cont
Cs:     st      0(1)                    ; reset to zero, carry now set.

Cont:   ld      0(1)                    ; display hex digits
        ani     0Fh
        xae
        ld      80h(3)
        st      @1(2)
        ldi     40h
        dly     00h
        ld      0(1)
        sr
        sr
        sr
        sr
        xae
        ld      80h(3)
        st      @2(2)                   ; leave a space. carry set if inc
        dld     Row                     ; next digit.
        jnz     Again

        ldi     3                       ; check alarm....
        st      Row
        ldi     0
        xae
Loop:   ld      @-1(1)                  ; check alarm byte
        xor     4(1)                    ; will be non-zero if changed
        ore                             ; or with E
        xae                             ; put in E
        dld     Row
        jnz     Loop
        xae                             ; if E is non-zero the alarm != time
        jz      Alarm
        lde                             ; A = 0
        jmp     Contin                  ; continue
Alarm:  ldi     07                      ; A = 7
        nop
Contin: cas                             ; light F0 F1 F2 if alarm
        ldi     02                      ; speed synchronisation
        dly     11h
        jmp     New                     ; go back.
        .end




